\ProvidesClass{phdthesis}

\DeclareOption{doublespacing}{%
\def\mysp@cing{1.6} %%% double spacing
}

\DeclareOption{oneandahalfspacing}{%
\def\mysp@cing{1.3} %%% one-and-a-half spacing
}

\ExecuteOptions{oneandahalfspacing}

\ProcessOptions


\LoadClass[11pt,a4paper]{report}
\RequirePackage[dvipsnames,usenames]{xcolor}

\linespread{\mysp@cing}

\paperheight=297mm%
\paperwidth=210mm%

\textheight=606pt%
\textwidth=415pt%

\voffset=-1in%
\hoffset=-1in%
\evensidemargin=1in%
\oddsidemargin=\paperwidth%
\addtolength{\oddsidemargin}{-\textwidth}%
\addtolength{\oddsidemargin}{-\evensidemargin}%
%\marginparsep=0in%
\marginparwidth=1cm%

\topmargin=1in%
\addtolength{\topmargin}{28pt}%
\headheight=12pt%
\headsep=20pt%
\footskip=36pt%



\def\@schapter#1{\addcontentsline{toc}{chapter}{#1}%
                   \@makeschapterhead{#1}%
                   \@afterheading
}

\def\@makechapterhead#1{%
  \vspace*{10\p@}%
  {\parindent \z@ \normalfont %\raggedright \normalfont%
    \ifnum \c@secnumdepth >\m@ne%
        \mbox{}\hfill {\fontseries{m}\fontshape{it}\fontsize{144}{160}\selectfont \colorbox{Gray!10}{\hspace*{0.5em}\rule[-0.25ex]{0pt}{2ex}\thechapter} %\huge\@chapapp\space
        \par}\nobreak%
        \vskip 60\p@%
    \fi%
    \interlinepenalty\@M%
    \Huge \bfseries #1\par\nobreak%
    \vskip 40\p@%
  }%
}%

\def\ps@headings{%
      \let\@oddfoot\@empty\let\@evenfoot\@empty
      \def\@evenhead{\parbox{\textwidth}{\thepage\hfill\itshape\leftmark\\[-12pt]\rule{\textwidth}{0.2pt}}}%
      \def\@oddhead{\parbox{\textwidth}{{\itshape\rightmark}\hfill\thepage\\[-12pt]\rule{\textwidth}{0.2pt}}}%
      \let\@mkboth\markboth
%
\def\chaptermark##1{%
      \markboth{{%
       Chapter \thechapter. \ %
        ##1}}{}}%
%
\def\sectionmark##1{%
      \markright {{%
        \ifnum \c@secnumdepth >\z@
          \thesection \ \ %
        \fi
        ##1}}}
}%

\renewenvironment{thebibliography}[1]
     {\chapter*{\bibname}% 
      \@mkboth{\bibname}{\bibname}% NO \MakeUppercase
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m
     }
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist
     }


\renewenvironment{theindex}
               {\if@twocolumn
                  \@restonecolfalse
                \else
                  \@restonecoltrue
                \fi
                \addcontentsline{toc}{chapter}{\indexname}% ADDED
                \twocolumn[\@makeschapterhead{\indexname}]%
                \@mkboth{\indexname}% NO \MakeUppercase
                        {\indexname}% NO \MakeUppercase
                \thispagestyle{plain}\parindent\z@
                \parskip\z@ \@plus .3\p@\relax
                \columnseprule \z@
                \columnsep 35\p@
                \let\item\@idxitem}
               {\if@restonecol\onecolumn\else\clearpage\fi}


\newcommand{\nb}[1]{$|$\marginpar{\tiny #1}}


